
<div class="container bd" >
    <h1>var 和 let</h1>
    <pre et>
var : 变量在函数外则是全局变量，有全局作用域，全局变量在页面关闭后销毁；变量在函数内则是局部变量，作用局部作用域（变量只能在该函数内有效，函数执行完将自动销毁）
let : let声明的变量是块级作用域的。循环中不会共享一个值
    </pre>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
var data = {
    'name':'rimke', 
    'QQ':'466814195', 
    'brand':'39doo', 
    'company':'etsoftware'
};
var fun1={};
for(var k in data){
    fun1[k] = function(){
        return data[k];
    }
}
/*
生成后输出结果都为同一值 etsoftware：
fun1.name(); // etsoftware
fun1.QQ(); // etsoftware
fun1.brand(); // etsoftware
fun1.company(); // etsoftware


*/
        </pre>
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
var data = {
    'name':'rimke', 
    'QQ':'466814195', 
    'brand':'39doo', 
    'company':'etsoftware'
};
var fun1={};
for(let k in data){
    fun1[k] = function(){
        return data[k];
    }
}
/*
生成后输出结果：
fun1.name(); // rimke
fun1.QQ(); // 466814195
fun1.brand(); // 39doo
fun1.company(); // etsoftware

 let声明的变量是块级作用域的。循环中不会共享一个值。
*/
        </pre>
    </div>    
</div>

<div class="container bd" >
    <h1>大尖头(=>)与 function</h1>
    <pre et>
在ES6中 function 简写方式 (..)=>...
    </pre>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
var data = [
    'name','rimke', 
    'QQ','466814195', 
    'brand','39doo', 
    'company','etsoftware'
];
var result = data.map(function(e){ return e+'/et'; });
/*
result 输出结果：
[
    "name/et",
    "rimke/et",
    "QQ/et",
    "466814195/et",
    "brand/et",
    "39doo/et",
    "company/et",
    "etsoftware/et"
]
*/
        </pre>
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
var data = [
    'name','rimke', 
    'QQ','466814195', 
    'brand','39doo', 
    'company','etsoftware'
];
var result = data.map((e)=>e+'/et');
/*
result 输出结果：
[
    "name/et",
    "rimke/et",
    "QQ/et",
    "466814195/et",
    "brand/et",
    "39doo/et",
    "company/et",
    "etsoftware/et"
]
*/
        </pre>
    </div>    
</div>

<div class="container bd" >
    <h1>...扩展运算符</h1>
    <pre et>
对象中的扩展运算符(...)用于取出参数对象中的所有可遍历属性，拷贝到当前对象之中
    </pre>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
let bar = { a: 1, b: 2 };
let baz = { ...bar }; // { a: 1, b: 2 }
        </pre>
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
let bar = { a: 1, b: 2 };
let baz = Object.assign({}, bar); // { a: 1, b: 2 }
        </pre>
    </div> 

    <div class="col-sm-6">
        <pre et type="text/javascript" >
function f(...arg){
    console.log(arg);
}
f(111,222,333); // [111,222,333];
        </pre>
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
function f(){
    console.log(arguments);
}
f(111,222,333); // [111,222,333,.....];
        </pre>
    </div>


    <div class="col-sm-6">
        <pre et type="text/javascript" >
function f(name, qq, brand, company){
    console.log({name:name, qq:qq, brand:brand, company:company});
}
var data = [
    'rimke', 
    '466814195', 
    '39doo', 
    'etsoftware'
];
f(...data);
/*
输出结果：
{
    name: "rimke", 
    qq: "466814195", 
    brand: "39doo", 
    company: "etsoftware"
}
*/
        </pre>
    </div>
    <div class="col-sm-6">
        <pre et type="text/javascript" >
function f(name, qq, brand, company){
    console.log({name:name, qq:qq, brand:brand, company:company});
}
var data = [
    'rimke', 
    '466814195', 
    '39doo', 
    'etsoftware'
];
f.apply(this, data);
/*
输出结果：
{
    name: "rimke", 
    qq: "466814195", 
    brand: "39doo", 
    company: "etsoftware"
}
*/
        </pre>
    </div>


</div>
